## mingw-w64-widelands-1.2.1-1.src.tar.zst

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.12)
cmake_policy(VERSION 3.12)

project (widelands)

message(STATUS "Using CMake version ${CMAKE_VERSION}")

# Detailed help is in README.md
# Please update it if you change anything here
option(OPTION_USE_GLBINDING "Use glbinding instead of GLEW" OFF)
option(OPTION_GLEW_STATIC "Use static GLEW Library" OFF)
option(OPTION_BUILD_WEBSITE_TOOLS "Build website-related tools" ON)
option(OPTION_BUILD_TRANSLATIONS "Build translations" ON)
option(OPTION_BUILD_TESTS "Build tests" ON)
option(OPTION_BUILD_CODECHECK "Build codecheck" ON)
option(OPTION_BUILD_WINSTATIC "Build a static linked .exe on windows" OFF)
option(OPTION_TSAN "Build with ThreadSanitizer" OFF)
option(OPTION_FORCE_EMBEDDED_MINIZIP "Use embedded minizip sources" OFF)
option(USE_XDG "Follow XDG-Basedir specification" ON) # Enabled by default

set(CMAKE_FIND_FRAMEWORK LAST)

# Absolute path reference for submodules
set(WL_ROOT_DIR "${CMAKE_CURRENT_SOURCE_DIR}")

# Add custom includes to override system libs
FILE(GLOB custom_include_directories auto_dependencies/*)
foreach(custom_include_dir ${custom_include_directories})
  if(IS_DIRECTORY "${custom_include_dir}")
    message(STATUS "Using custom include directory '${custom_include_dir}'.")
    list(INSERT CMAKE_INCLUDE_PATH 0 "${custom_include_dir}")
    include_directories(BEFORE SYSTEM "${custom_include_dir}")
  else()
    message(WARNING "Not a directory: '${custom_include_dir}' - Ignored.")
  endif()
endforeach()

include("${CMAKE_SOURCE_DIR}/cmake/UseSystemInfo.cmake")
include("${CMAKE_SOURCE_DIR}/cmake/WlFunctions.cmake")

# This policy is not known to versions prior 3.27 and would result in errors,
# if set on such systems. This can be removed when cmake_minimum_required is set
# to 3.27 or newer  by using:
# cmake_policy(VERSION 3.27)
if(POLICY CMP0148)
  cmake_policy(SET CMP0148 NEW)
endif(POLICY CMP0148)

IF(USE_XDG AND NOT APPLE AND NOT WIN32)
  ADD_DEFINITIONS(-DUSE_XDG)
  message(STATUS "Building with XDG support")
ENDIF(USE_XDG AND NOT APPLE AND NOT WIN32)

if (CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)
  message(FATAL_ERROR "Build directory and source directory must not be the same.")
endif (CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)

# Define the directory structure for installation - will be hardcoded in WL bin
# (through config.h). If not specified, we are going to use the directory where
# the executable is in. Also on Linux.
# Packagers (or people using make install) have to set this variable to an absolute path.
wl_set_if_unset(WL_INSTALL_BASEDIR ".")

# Define the directory structure for installation of the data files - will be hardcoded
# in WL bin (through config.h). If not specified, we are going to use the "data" directory
# below the directory where the executable is in. Also on Linux.
# Packagers (or people using make install) have to set this variable to an absolute path.
wl_set_if_unset(WL_INSTALL_DATADIR "./data")

# To override this, use '-DWL_INSTALL_BINDIR=<absolute path>' when configuring or change
# 'CMAKE_INSTALL_PREFIX'.
# Example: to have the bin installed to "/usr/games", just use '-DCMAKE_INSTALL_PREFIX=/usr'
# and don't specify '-DWL_INSTALL_BINDIR' when configuring.
# Note: 'CMAKE_INSTALL_PREFIX' defaults to /usr/local on UNIX and c:/Program Files/${PROJECT_NAME} on Windows
wl_set_if_unset(WL_INSTALL_BINDIR "${CMAKE_INSTALL_PREFIX}/games")

if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
  if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS 4.8)
    message(FATAL_ERROR "Widelands needs GCC >= 4.8 to compile.")
  endif()
elseif("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang" OR "${CMAKE_CXX_COMPILER_ID}" STREQUAL "AppleClang")
  if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS 3.4)
    message(FATAL_ERROR "Clang version must be at least 3.4!")
  endif()
elseif("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC")
  if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS 3.4)
    message(FATAL_ERROR "MSVC version must be at least 19!")
  endif()
else()
  message(WARNING "You are using an unsupported compiler! Supported are Clang and GCC.")
endif()
message(STATUS "Picking up default CXX flags:
    - CMAKE_CXX_FLAGS='${CMAKE_CXX_FLAGS}'
    - CMAKE_CXX_FLAGS_RELEASE='${CMAKE_CXX_FLAGS_RELEASE}'
    - CMAKE_CXX_FLAGS_DEBUG='${CMAKE_CXX_FLAGS_DEBUG}'")

SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules)

if (WIN32)
  link_libraries(wsock32 ws2_32 bcrypt)
endif()
if (OPTION_BUILD_WINSTATIC)
  add_definitions(-DGLBINDING_STATIC_DEFINE -DNGHTTP2_STATICLIB)
  set (OPTION_GLEW_STATIC ON)
  if(MSVC)
    set(CMAKE_FIND_LIBRARY_SUFFIXES ".lib")
  else()
    set(CMAKE_FIND_LIBRARY_PREFIXES "lib")
    set(CMAKE_FIND_LIBRARY_SUFFIXES ".a")
  endif()
endif()

find_package (Python3 REQUIRED)

find_package(Gettext REQUIRED)
find_package(OpenGL REQUIRED)
find_package(PNG 1.6 REQUIRED)

find_package(SDL2 REQUIRED)
find_package(SDL2_image REQUIRED)
find_package(SDL2_mixer REQUIRED)
find_package(SDL2_ttf REQUIRED)
find_package(ZLIB REQUIRED)
if(${CMAKE_VERSION} VERSION_LESS 3.9.0)
    find_package(ICU_old REQUIRED)
else()
    find_package(ICU REQUIRED COMPONENTS uc dt)
endif()
if(OPTION_USE_GLBINDING)
  find_package(glbinding REQUIRED)
else()
  find_package(GLEW REQUIRED)
endif()

# Check that Asio is installed. Asio does not have (or need) a Find… CMake Module, so we "only" need to check if the header exists.
if(NOT asio_location OR asio_location STREQUAL "")
  unset(asio_location CACHE)
  find_path(asio_location "asio.hpp")
  if(asio_location)
    message(STATUS "Found Asio in '${asio_location}'.")
  else()
    message(FATAL_ERROR "Could NOT find Asio (missing: asio.hpp). Please run:\n./install-dependencies.sh\nwhich will attempt to install all missing dependencies automatically, or provide further instructions if this not supported on your system.")
  endif()
endif()
add_definitions(-DASIO_STANDALONE)

if (APPLE OR WIN32 OR
    CMAKE_SYSTEM_NAME MATCHES "FreeBSD" OR
    CMAKE_SYSTEM_NAME MATCHES "NetBSD" OR
    CMAKE_SYSTEM_NAME MATCHES "OpenBSD")
  if (NOT CMAKE_SYSTEM_NAME MATCHES "kFreeBSD")
    find_package(Intl REQUIRED)
  endif()
endif()

# Disable no symbols warning on macOS, but only on versions where this is
# supported. It is not supported on OS X 10.7 (DARWIN_MAJOR_VERSION == 11).
if (APPLE)
    if (${DARWIN_MAJOR_VERSION} GREATER 11)
        SET(CMAKE_C_ARCHIVE_CREATE   "<CMAKE_AR> Scr <TARGET> <LINK_FLAGS> <OBJECTS>")
        SET(CMAKE_CXX_ARCHIVE_CREATE "<CMAKE_AR> Scr <TARGET> <LINK_FLAGS> <OBJECTS>")
        SET(CMAKE_C_ARCHIVE_FINISH   "<CMAKE_RANLIB> -no_warning_for_no_symbols -c <TARGET>")
        SET(CMAKE_CXX_ARCHIVE_FINISH "<CMAKE_RANLIB> -no_warning_for_no_symbols -c <TARGET>")
    endif()
endif()

# TODO(sirver): One day, this should be enabled. Then we have no more cycles in our dependencies....
# set_property(GLOBAL PROPERTY GLOBAL_DEPENDS_NO_CYCLES ON)

if (NOT CMAKE_BUILD_TYPE OR CMAKE_BUILD_TYPE STREQUAL "")
  find_path(FILE_WL_RELEASE "WL_RELEASE" ${CMAKE_CURRENT_SOURCE_DIR})
  if(${FILE_WL_RELEASE} STREQUAL "FILE_WL_RELEASE-NOTFOUND")
    set(CMAKE_BUILD_TYPE Debug)
  else()
    set(CMAKE_BUILD_TYPE Release)
  endif()
endif (NOT CMAKE_BUILD_TYPE OR CMAKE_BUILD_TYPE STREQUAL "")

if(CMAKE_BUILD_TYPE STREQUAL "Debug")
  set(WL_DEBUG_FLAGS "-DDEBUG")
  if(NOT MSVC)
    wl_add_flag(WL_DEBUG_FLAGS "-g")
    if(NOT OPTION_TSAN)
      option(OPTION_ASAN "Build with AddressSanitizer" ON)
    endif()
  endif()
elseif((CMAKE_BUILD_TYPE STREQUAL "Release") OR (CMAKE_BUILD_TYPE STREQUAL "RelWithDebInfo"))
  if(("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU") AND (CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 7.5))
    message(STATUS "GCC >7.5.0 breaks -O3, setting -O2")
    set(WL_OPTIMIZE_FLAGS "-O2")
  elseif(MSVC)
    set(WL_OPTIMIZE_FLAGS "/O2")
  else()
    set(WL_OPTIMIZE_FLAGS "-O3")
  endif()
  if(("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU") AND (CMAKE_CXX_COMPILER_VERSION VERSION_LESS 7.6))
    message(WARNING "GCC <7.6.0 is known to cause segfaults in release builds. Please consider upgrading to GCC version 7.6 or newer or using Clang. Adding selected overrides to suppress reporting of known bugs.")
    wl_add_flag(WL_OPTIMIZE_FLAGS "--param asan-stack=0")
  endif()
  set(WL_DEBUG_FLAGS "-DNDEBUG -DNOPARACHUTE")
  option(OPTION_ASAN "Build with AddressSanitizer" OFF)
elseif(CMAKE_BUILD_TYPE STREQUAL "None")
  message(STATUS "Not setting any default flags.")
else()
  message(FATAL_ERROR "Unknown CMAKE_BUILD_TYPE: ${CMAKE_BUILD_TYPE}")
endif()

if(OPTION_TSAN)
  message(STATUS "Using ThreadSanitizer https://clang.llvm.org/docs/ThreadSanitizer.html")
  wl_add_flag(WL_COMPILE_DIAGNOSTICS "-fsanitize=thread")
  set (CMAKE_EXE_LINKER_FLAGS "-fsanitize=thread" CACHE STRING "Set by widelands CMakeLists.txt" FORCE)
  option(OPTION_ASAN "Build with AddressSanitizer" OFF)
else()
  message(STATUS "Not using ThreadSanitizer.")
endif(OPTION_TSAN)

if(OPTION_ASAN)
  message(STATUS "Using AddressSanitizer https://clang.llvm.org/docs/AddressSanitizer.html")
  # See https://clang.llvm.org/docs/AddressSanitizer.html
  wl_add_flag(WL_COMPILE_DIAGNOSTICS "-fsanitize=address")
  wl_add_flag(WL_COMPILE_DIAGNOSTICS "-fno-omit-frame-pointer")
  set (CMAKE_EXE_LINKER_FLAGS "-fsanitize=address" CACHE STRING "Set by widelands CMakeLists.txt" FORCE)
  add_definitions(-DUSE_ASAN)
else()
  message(STATUS "Not using AddressSanitizer.")
endif(OPTION_ASAN)

if(OPTION_ASAN AND OPTION_TSAN)
  message(FATAL_ERROR "OPTION_ASAN and OPTION_TSAN cannot be used together")
endif()

# This is set to avoid linker errors when using GLVND-libs on Linux
if("${OpenGL_GL_PREFERENCE}" STREQUAL "GLVND")
   link_libraries(OpenGL::GL)
   add_compile_definitions(WL_USE_GLVND)
   message(STATUS "Adding linker flags for GLVND.")
endif()

if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
  set(warn_disable_flags
    "-Weverything"

    # Disabled warnings that are overly verbose right now or just do not make sense.
    "-Wno-c++98-compat"
    "-Wno-c++98-compat-pedantic"
    "-Wno-conversion"
    "-Wno-exit-time-destructors"
    "-Wno-global-constructors"
    "-Wno-padded"
    "-Wno-sign-conversion"
    "-Wno-missing-noreturn"

    # It is impossible to write code that both GCC and Clang will like,
    # so we have to switch off the warning for one of them.
    # http://clang-developers.42468.n3.nabble.com/Question-on-Wswitch-enum-td4025927.html
    "-Wno-switch-enum"

    # TODO(sirver: weak-vtables should be enabled, but leads to lot of errors right now.
    "-Wno-weak-vtables"
    "-Wno-unreachable-code"
    "-Wno-documentation"
    "-Qunused-arguments"
    "-Wint-to-void-pointer-cast"
  )
  foreach(flag IN LISTS warn_disable_flags)
    wl_add_flag(WL_COMPILE_DIAGNOSTICS ${flag})
  endforeach()

  if(CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 3.8)
    wl_add_flag(WL_COMPILE_DIAGNOSTICS "-Winconsistent-missing-override")
  endif()
  if(CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 16)
    wl_add_flag(WL_COMPILE_DIAGNOSTICS "-Wno-unsafe-buffer-usage")
  endif()
elseif(MSVC)
  wl_add_flag(WL_GENERIC_CXX_FLAGS "/std:c++17")
  # https://docs.microsoft.com/en-us/cpp/error-messages/compiler-warnings/
  # Disabled warnings that are overly verbose right now or just do not make sense.
  wl_add_flag(WL_COMPILE_DIAGNOSTICS "/wd4244")
  wl_add_flag(WL_COMPILE_DIAGNOSTICS "/wd4267")
  wl_add_flag(WL_COMPILE_DIAGNOSTICS "/wd4018")
  # Use correct code page
  wl_add_flag(WL_GENERIC_CXX_FLAGS "/utf-8")
else()
  # Assuming GCC 4.8 or higher.
  if(WIN32)
    # This is needed for getenv().
    wl_add_flag(WL_GENERIC_CXX_FLAGS "-std=gnu++17")
    if (OPTION_BUILD_WINSTATIC)
      set(CMAKE_CXX_STANDARD_LIBRARIES "-static-libgcc -static-libstdc++ ${CMAKE_CXX_STANDARD_LIBRARIES}")
      set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-Bstatic")
    endif()
  else()
    # SDL and MinGW both declare 'unsigned int __builtin_ia32_crc32qi(unsigned int, unsigned char)', resulting in lots of warnings. So, we can't have this flag in Windows.

=== xdg/CMakeLists.txt ===
# GNUInstallDirs requires CMake >= 3.0.2
#include(GNUInstallDirs)

set(XDG_APPLICATION_ID "org.widelands.Widelands")

list(APPEND icon_sizes "16" "32" "48" "64" "128")
foreach (icon_size ${icon_sizes})
  #install(FILES ${CMAKE_SOURCE_DIR}/data/images/logos/wl-ico-${icon_size}.png DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/${icon_size}x${icon_size}/apps RENAME ${XDG_APPLICATION_ID}.png)
  install(FILES ${CMAKE_SOURCE_DIR}/data/images/logos/wl-ico-${icon_size}.png DESTINATION ${CMAKE_INSTALL_PREFIX}/share/icons/hicolor/${icon_size}x${icon_size}/apps RENAME ${XDG_APPLICATION_ID}.png)
endforeach (icon_size ${icon_sizes})
#install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/${CMAKE_PROJECT_NAME}.6           DESTINATION ${CMAKE_INSTALL_MANDIR}/man6)
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/${CMAKE_PROJECT_NAME}.6           DESTINATION ${CMAKE_INSTALL_PREFIX}/share/man/man6)
#install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/${XDG_APPLICATION_ID}.desktop     DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/applications)
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/${XDG_APPLICATION_ID}.desktop     DESTINATION ${CMAKE_INSTALL_PREFIX}/share/applications)
#install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/${XDG_APPLICATION_ID}.appdata.xml DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/metainfo)
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/${XDG_APPLICATION_ID}.appdata.xml DESTINATION ${CMAKE_INSTALL_PREFIX}/share/metainfo)

# TODO: check for privileges
# If 'make install' was run without superuser privileges, the user will get a "permission denied" error
# when 'gtk-update-icon-cache' is executed
find_program(GTK_UPDATE_ICON_CACHE NAMES gtk-update-icon-cache)
if (GTK_UPDATE_ICON_CACHE)
  #install(CODE "execute_process (COMMAND ${GTK_UPDATE_ICON_CACHE} -t -f ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor ||: )")
  install(CODE "execute_process (COMMAND ${GTK_UPDATE_ICON_CACHE} -t -f ${CMAKE_INSTALL_PREFIX}/share/icons/hicolor ||: )")
else (GTK_UPDATE_ICON_CACHE)
  message(WARNING "gtk-update-icon-cache not found!")
endif (GTK_UPDATE_ICON_CACHE)

=== src/editor/CMakeLists.txt ===
wl_library(editor
  SRCS
    editorinteractive.cc
    editorinteractive.h
    editor_category.cc
    editor_category.h
    map_generator.cc
    map_generator.h
    tools/action_args.h
    tools/decrease_height_tool.cc
    tools/decrease_height_tool.h
    tools/decrease_resources_tool.cc
    tools/decrease_resources_tool.h
    tools/delete_critter_tool.cc
    tools/delete_critter_tool.h
    tools/delete_immovable_tool.cc
    tools/delete_immovable_tool.h
    tools/draw_tool.cc
    tools/draw_tool.h
    tools/history.cc
    tools/history.h
    tools/increase_height_tool.cc
    tools/increase_height_tool.h
    tools/increase_resources_tool.cc
    tools/increase_resources_tool.h
    tools/info_tool.cc
    tools/info_tool.h
    tools/multi_select.h
    tools/noise_height_tool.cc
    tools/noise_height_tool.h
    tools/place_critter_tool.cc
    tools/place_critter_tool.h
    tools/place_immovable_tool.cc
    tools/place_immovable_tool.h
    tools/resize_tool.cc
    tools/resize_tool.h
    tools/set_height_tool.cc
    tools/set_height_tool.h
    tools/set_origin_tool.cc
    tools/set_origin_tool.h
    tools/set_port_space_tool.cc
    tools/set_port_space_tool.h
    tools/set_resources_tool.cc
    tools/set_resources_tool.h
    tools/set_starting_pos_tool.cc
    tools/set_starting_pos_tool.h
    tools/set_terrain_tool.cc
    tools/set_terrain_tool.h
    tools/tool.h
    tools/tool_action.h
    tools/tool_conf.cc
    tools/tool_conf.h
    tools/toolhistory_tool.cc
    tools/toolhistory_tool.h
    ui_menus/categorized_item_selection_menu.h
    ui_menus/field_info_window.h
    ui_menus/field_info_window.cc
    ui_menus/help.cc
    ui_menus/help.h
    ui_menus/main_menu_load_map.cc
    ui_menus/main_menu_load_map.h
    ui_menus/main_menu_load_or_save_map.cc
    ui_menus/main_menu_load_or_save_map.h
    ui_menus/main_menu_map_options.cc
    ui_menus/main_menu_map_options.h
    ui_menus/main_menu_new_map.cc
    ui_menus/main_menu_new_map.h
    ui_menus/main_menu_random_map.cc
    ui_menus/main_menu_random_map.h
    ui_menus/main_menu_save_map.cc
    ui_menus/main_menu_save_map.h
    ui_menus/main_menu_save_map_make_directory.cc
    ui_menus/main_menu_save_map_make_directory.h
    ui_menus/map_size_box.cc
    ui_menus/map_size_box.h
    ui_menus/player_menu.cc
    ui_menus/player_menu.h
    ui_menus/tool_change_height_options_menu.cc
    ui_menus/tool_change_height_options_menu.h
    ui_menus/tool_change_resources_options_menu.cc
    ui_menus/tool_change_resources_options_menu.h
    ui_menus/tool_noise_height_options_menu.cc
    ui_menus/tool_noise_height_options_menu.h
    ui_menus/tool_options_menu.cc
    ui_menus/tool_options_menu.h
    ui_menus/tool_place_critter_options_menu.cc
    ui_menus/tool_place_critter_options_menu.h
    ui_menus/tool_place_immovable_options_menu.cc
    ui_menus/tool_place_immovable_options_menu.h
    ui_menus/tool_resize_options_menu.cc
    ui_menus/tool_resize_options_menu.h
    ui_menus/tool_set_terrain_options_menu.cc
    ui_menus/tool_set_terrain_options_menu.h
    ui_menus/tool_toolhistory_options_menu.cc
    ui_menus/tool_toolhistory_options_menu.h
    ui_menus/toolsize_menu.cc
    ui_menus/toolsize_menu.h
  USES_SDL2
  DEPENDS
    base
    base_exceptions
    base_macros
    base_random
    base_scoped_timer
    build_info
    graphic
    graphic_fonthandler
    graphic_mouse_cursor
    graphic_playercolor
    graphic_surface
    graphic_text_layout
    io_filesystem
    io_filesystem_illegal_filename_check
    logic
    logic_addons
    logic_constants
    logic_exceptions
    logic_filesystem_constants
    logic_generic_save_handler
    logic_map
    logic_map_object_type
    logic_map_objects
    logic_map_objects_description_maintainer
    logic_single_player_game_settings
    logic_tribe_basic_info
    logic_widelands_geometry
    map_io
    map_io_map_loader
    network
    scripting_lua_interface
    scripting_lua_table
    sound
    ui_addons
    ui_basic
    widelands_options
    wui
    wui_common_mapdetails
)

=== src/game_io/CMakeLists.txt ===
wl_library(game_io
  SRCS
    game_cmd_queue_packet.cc
    game_cmd_queue_packet.h
    game_data_packet.h
    game_class_packet.cc
    game_class_packet.h
    game_interactive_player_packet.cc
    game_interactive_player_packet.h
    game_player_ai_persistent_packet.cc
    game_player_ai_persistent_packet.h
    game_loader.cc
    game_loader.h
    game_map_packet.cc
    game_map_packet.h
    game_player_economies_packet.cc
    game_player_economies_packet.h
    game_player_info_packet.cc
    game_player_info_packet.h
    game_preload_packet.cc
    game_preload_packet.h
    game_saver.cc
    game_saver.h
  DEPENDS
    base
    base_exceptions
    base_macros
    base_scoped_timer
    base_times
    build_info
    economy
    graphic_image_io
    graphic_minimap_renderer
    io_fileread
    io_filesystem
    io_profile
    logic
    logic_addons
    logic_commands
    logic_exceptions
    logic_game_controller
    logic_map
    logic_map_objects
    logic_widelands_geometry_io
    map_io
    map_io_map_loader
    scripting_lua_table
    ui_basic
    wui
    wui_mapview
    wui_mapview_pixelfunctions
)

=== src/sound/CMakeLists.txt ===
wl_library(note_sound
  SRCS
    note_sound.h
    note_sound.cc
  DEPENDS
    logic_widelands_geometry
    notifications
    sound_constants
)

wl_library(sound_constants
  SRCS
    constants.cc
    constants.h
)

wl_library(sound
  SRCS
    fxset.cc
    fxset.h
    songset.cc
    songset.h
    sound_handler.cc
    sound_handler.h
  USES_SDL2
  USES_SDL2_MIXER
  DEPENDS
    base
    base_macros
    base_random
    io_fileread
    io_filesystem
    logic_exceptions
    sound_constants
    widelands_options
)

=== src/base/test/CMakeLists.txt ===
wl_test(test_base
  SRCS
    base_test_main.cc
    test_crypto.cc
    test_geometry.cc
    test_math.cc
    test_times.cc
    test_time_string.cc
    test_utf8.cc
    test_string.cc
  DEPENDS
    base
    base_crypto
    base_geometry
    base_math
    base_test
    base_times
    base_time_string
    base_utf8
)

=== src/economy/test/CMakeLists.txt ===
wl_test(test_economy
  SRCS
    economy_test_main.cc
    test_road.cc
    test_routing.cc
  DEPENDS
    base_macros
    base_test
    economy
    io_filesystem
    logic
    logic_map_objects
    logic_widelands_geometry
)

=== src/graphic/styles/CMakeLists.txt ===
wl_library(graphic_styles
  SRCS
    building_statistics_style.h
    button_style.cc
    button_style.h
    font_style.cc
    font_style.h
    panel_styles.h
    paragraph_style.cc
    paragraph_style.h
    progress_bar_style.h
    text_panel_style.h
    statistics_plot_style.h
    table_style.h
    ware_info_style.h
    window_style.h
  DEPENDS
    base
    base_exceptions
    graphic_color
    graphic_surface
    graphic_text_layout
)

=== src/ui_fsmenu/addons/CMakeLists.txt ===
wl_library(ui_addons
  SRCS
    contact.cc
    contact.h
    login_box.cc
    login_box.h
    manager.cc
    manager.h
    packager.cc
    packager.h
    packager_box.cc
    packager_box.h
    progress.cc
    progress.h
    remote_interaction.cc
    remote_interaction.h
    rows_ui.cc
    rows_ui.h
    screenshot_upload.cc
    screenshot_upload.h
  DEPENDS
    base_crypto
    base_time_string
    scripting_lua_table
    logic_filesystem_constants
    logic_tribe_basic_info
    io_filesystem
    graphic_text_layout
    ui_basic
    base
    io_filesystem_illegal_filename_check
    ui_fsmenu
    widelands_ball_of_mud
    io_profile
    base_exceptions
    logic
    widelands_options
    graphic_fonthandler
    logic_addons
    network
    graphic
    wui_common_mapdetails
)

=== PKGBUILD ===
# Maintainer: Konstantin Podsvirov <konstantin@podsvirov.su>

_realname=widelands
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=1.2.1
pkgrel=1
pkgdesc="A realtime strategy game with emphasis on economy and transport (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url='https://widelands.org/'
msys2_repository_url='https://github.com/widelands/widelands'
msys2_references=(
  'archlinux: widelands'
)
license=('spdx:GPL-2.0-or-later')
depends=("${MINGW_PACKAGE_PREFIX}-SDL2_mixer"
         "${MINGW_PACKAGE_PREFIX}-SDL2_image"
         "${MINGW_PACKAGE_PREFIX}-SDL2_ttf"
         "${MINGW_PACKAGE_PREFIX}-icu"
         "${MINGW_PACKAGE_PREFIX}-lua"
         "${MINGW_PACKAGE_PREFIX}-glew"
         "${MINGW_PACKAGE_PREFIX}-python"
         "${MINGW_PACKAGE_PREFIX}-dbus"
         "${MINGW_PACKAGE_PREFIX}-minizip")
makedepends=("${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-asio")
source=("${msys2_repository_url}/archive/v${pkgver}/${_realname}-${pkgver}.tar.gz"
        "${msys2_repository_url}/commit/c0b44ccc04df35a9a23ca9be3e05f5d3a5428f6f.patch"
        "${msys2_repository_url}/commit/a66872f35abe45a2eba6c112dd978bd9e2c08d7b.patch"
        "${msys2_repository_url}/commit/a20d8d240e68c5ae704bbb754472130ae72ebfa9.patch"
        "${msys2_repository_url}/commit/937a1695cf0494bba559b489497ca99afdf95983.patch"
        '0001-wideland-1.2.1-relative-datadir.patch')

sha256sums=('799bfd32048ef20118c48e21f3fc843ae0451c42bb8bf2eabcb9b26bf6fe54b4'
            'c560c9125fae38fbe89556f82e4df9e40b250060dc5c6b64c0535bb2158e18ea'
            '0fb1249b4f3dedcb6efe2fe9210976aac0ba1d15d617eb61e1a5b7de6e679b79'
            'b3bbb877a87c9fbb68be62def4c37a1981fed44fddbedb61e950a06242e880a3'
            'efde065633f72780a08b6e8a60f26630532079c76eb0a1866fd3e5faf1ac3be1'
            'd01990e76cf884a464f491d7c79bd60443e30a752a91a9e20fa12e69f478e73f')

prepare() {
  cd "${_realname}-${pkgver}"

  # Backport of https://github.com/widelands/widelands/pull/6665 (fixes build with asio 1.34)
  patch -Np1 -i "${srcdir}/c0b44ccc04df35a9a23ca9be3e05f5d3a5428f6f.patch"
  # Backport of https://github.com/widelands/widelands/pull/6522 (fixes build with GCC 15)
  patch -Np1 -i "${srcdir}/a66872f35abe45a2eba6c112dd978bd9e2c08d7b.patch"
  patch -Np1 -i "${srcdir}/a20d8d240e68c5ae704bbb754472130ae72ebfa9.patch"
  # Backport of https://github.com/widelands/widelands/pull/6698 (fixes build with GCC 15)
  patch -Np1 -i "${srcdir}/937a1695cf0494bba559b489497ca99afdf95983.patch"

  # Search datadir relative to ${MINGW_PREFIX}/bin/..
  patch -Np1 -i "${srcdir}/0001-wideland-1.2.1-relative-datadir.patch"
}

build() {
  declare -a extra_config
  if check_option "debug" "n"; then
    extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    cmake \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      "${extra_config[@]}" \
      -DBUILD_{SHARED,STATIC}_LIBS=ON \
      -DWL_INSTALL_BINDIR=bin \
      -DWL_INSTALL_DATADIR=share/widelands \
      -S "${_realname}-${pkgver}" \
      -B "build-${MSYSTEM}"

  cmake --build "build-${MSYSTEM}"
}

check() {
  cmake --build "build-${MSYSTEM}" --target test
}

package() {
  DESTDIR="${pkgdir}" cmake --install "build-${MSYSTEM}"

  # Fix wrong locations of some installed files (upstream bug)
  # See also FS#72240
  rm "${pkgdir}${MINGW_PREFIX}"/COPYING
  mv "${pkgdir}${MINGW_PREFIX}"/{VERSION,ChangeLog,CREDITS} "${pkgdir}${MINGW_PREFIX}"/share/widelands

  install -Dm644 "${srcdir}/${_realname}-${pkgver}/COPYING" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/COPYING"
}
